Skip site navigation (1)Skip section navigation (2)
Date:      Thu, 7 Jan 2016 17:00:35 +0000 (UTC)
From:      Ed Maste <emaste@FreeBSD.org>
To:        src-committers@freebsd.org, svn-src-all@freebsd.org, svn-src-stable@freebsd.org, svn-src-stable-10@freebsd.org
Subject:   svn commit: r293333 - stable/10/sys/conf
Message-ID:  <201601071700.u07H0Zu8067228@repo.freebsd.org>

next in thread | raw e-mail | index | archive | help
Author: emaste
Date: Thu Jan  7 17:00:35 2016
New Revision: 293333
URL: https://svnweb.freebsd.org/changeset/base/293333

Log:
  MFC r291691: newvers: Honour SOURCE_DATE_EPOCH for build reproducibility
  
  One reason the kernel does not build reproducibly is that it includes
  a timestamp in the version string. SOURCE_DATE_EPOCH provides a standard
  method to address this: it should be set to the last modification time
  of the source, and build processes use the specified timestamp instead
  of the "current" date and time.
  
  This change uses SOURCE_DATE_EPOCH if it is set; how it gets set needs
  to be addressed elsewhere.

Modified:
  stable/10/sys/conf/newvers.sh
Directory Properties:
  stable/10/   (props changed)

Modified: stable/10/sys/conf/newvers.sh
==============================================================================
--- stable/10/sys/conf/newvers.sh	Thu Jan  7 16:48:47 2016	(r293332)
+++ stable/10/sys/conf/newvers.sh	Thu Jan  7 17:00:35 2016	(r293333)
@@ -87,7 +87,15 @@ then
 fi
 
 touch version
-v=`cat version` u=${USER:-root} d=`pwd` h=${HOSTNAME:-`hostname`} t=`date`
+v=`cat version` u=${USER:-root} d=`pwd` h=${HOSTNAME:-`hostname`}
+if [ -n "$SOURCE_DATE_EPOCH" ]; then
+	if ! t=`date -r $SOURCE_DATE_EPOCH 2>/dev/null`; then
+		echo "Invalid SOURCE_DATE_EPOCH" >&2
+		exit 1
+	fi
+else
+	t=`date`
+fi
 i=`${MAKE:-make} -V KERN_IDENT`
 compiler_v=$($(${MAKE:-make} -V CC) -v 2>&1 | grep 'version')
 



Want to link to this message? Use this URL: <https://mail-archive.FreeBSD.org/cgi/mid.cgi?201601071700.u07H0Zu8067228>